#!/bin/bash -e

settingsXmlFile=$1
newVersion=$2

mvnVersionsUpdateParent() {
    mvn -B -N -e -s $settingsXmlFile versions:update-parent -Dfull\
     -DparentVersion="[$newVersion]" -DallowSnapshots=true -DgenerateBackupPoms=false
}

mvnVersionsUpdateChildModules() {
    mvn -B -N -e -s $settingsXmlFile versions:update-child-modules -Dfull\
     -DallowSnapshots=true -DgenerateBackupPoms=false
}


cd drools-eclipse
mvn -B -s $settingsXmlFile -Dfull tycho-versions:set-version -DnewVersion=$newVersion
returnCode=$?
# replace the leftovers not covered by the tycho plugin (bug?)
# SNAPSHOT and release versions need to be handled differently
versionToUse=$newVersion
if [[ $newVersion == *-SNAPSHOT ]]; then
   versionToUse=`sed "s/-SNAPSHOT/.qualifier/" <<< $newVersion`
fi
sed -i "s/source_[^\"]*/source_$versionToUse/" org.drools.updatesite/category.xml
sed -i "s/version=\"[^\"]*\">/version=\"$versionToUse\">/" org.drools.updatesite/category.xml
cd ..
if [ $returnCode == 0 ]; then
   mvn -B -N -s $settingsXmlFile clean install
   mvnVersionsUpdateParent
   # workaround for http://jira.codehaus.org/browse/MVERSIONS-161
   mvn -B -N -s $settingsXmlFile clean install -DskipTests
   cd drools-eclipse
   mvnVersionsUpdateParent
   cd ..
   mvnVersionsUpdateChildModules
   returnCode=$?
fi

